/* exec2.c - shows how easy it is for a process to run a program

   The exec() family of functions cause a program to be loaded
   into the current process. This means that the code from the
   process that calls exec() gets (completely) overwritten by the
   code of a another program and then the new program is started.

   The execvp() function expects a "command-line" like argument to
   tell it what program to run and what command-line parameters
   to pass to the new program.
*/
#include <unistd.h>
#include <stdio.h>

int main()
{
   /* build a command-line (a null terminated array of strings) */
   char *arglist[4];
   arglist[0] = "ls";
   arglist[1] = "-l";
   arglist[2] = "-a";
   arglist[3] = 0;

   printf("* * * About to exec ls -l -a\n");
   /* execute the command-line (in this process!!) */
   execvp("ls", arglist);

   perror("execvp failed"); /* We should not get here! */
   return 1;
}
