/* exec1.c - shows how easy it is for a process to run a program

   The exec() family of functions cause a program to be loaded
   into the current process. This means that the code from the
   process that calls exec() gets (completely) overwritten by the
   code of a another program and then the new program is started.

   The execvp() function expects a "command-line" like argument to
   tell it what program to run and what command-line parameters
   to pass to the new program.
*/
#include <unistd.h>
#include <stdio.h>

int main()
{
   /* build a command-line (a null terminated array of strings) */
   char *arglist[2];
   arglist[0] = "nano";
   arglist[1] = 0;

   printf("* * * About to exec nano\n");
   /* execute the command-line (in this process!!) */
   execvp("nano", arglist);

   perror("execvp failed");
   return 1;
}
